-- utilities class brought from the Mario project

function generateQuads (atlas, tileWidth, tileHeight)

    print("Util.lua")

    -- how many tiles horizontally and vertically
    local sheetWidth = atlas:getWidth() / tileWidth
    local sheetHeight = atlas:getWidth() / tileHeight

    local counter = 1   -- so we can make the table 1 indexed
    local quads = {}

    -- loop the atlas and add the tiles to the quads table
    for y = 0, sheetWidth - 1 do
        for x = 0, sheetHeight - 1 do
            quads[counter] = love.graphics.newQuad(
                x * tileWidth, y * tileHeight, tileWidth, tileHeight,atlas:getDimensions())
            counter = counter + 1
        end
    end

    return quads
end

-- https://www.love2d.org/wiki/BoundingBox.lua
-- Collision detection function;
-- Returns true if two boxes overlap, false if they don't;
-- x1,y1 are the top-left coords of the first box, while w1,h1 are its width and height;
-- x2,y2,w2 & h2 are the same, but for the second box.
function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end